#pragma semicolon 1
#pragma newdecls required
#include <sourcemod>
#include <vip_core>

public Plugin myinfo = 
{
	name = "[VIP] Time VIP",
	author = "R1KO",
	version = "2.0.2"
};

char g_szGroup[64];
char g_sStartTime[64];
char g_sEndTime[64];
bool g_bGive;
bool g_bGived[MAXPLAYERS+1];

public void OnPluginStart()
{
	ConVar hCvar = CreateConVar("sm_vip_time_group", "vip", "Группа VIP-статуса");
	HookConVarChange(hCvar, OnGroupChange);
	GetConVarString(hCvar, g_szGroup, sizeof(g_szGroup));

	hCvar = CreateConVar("sm_vip_time_start", "00:00", "Начало времени");
	HookConVarChange(hCvar, OnStartTimeChange);
	GetConVarString(hCvar, g_sStartTime, sizeof(g_sStartTime));

	hCvar = CreateConVar("sm_vip_time_end", "05:00", "Конец времени");
	HookConVarChange(hCvar, OnEndTimeChange);
	GetConVarString(hCvar, g_sEndTime, sizeof(g_sEndTime));

	AutoExecConfig(true, "time_vip", "vip");
}

public void OnGroupChange(ConVar hCvar, const char[] sOldValue, const char[] sNewValue)
{
	strcopy(g_szGroup, sizeof(g_szGroup), sNewValue);
}

public void OnStartTimeChange(ConVar hCvar, const char[] sOldValue, const char[] sNewValue)
{
	strcopy(g_sStartTime, sizeof(g_sStartTime), sNewValue);
}

public void OnEndTimeChange(ConVar hCvar, const char[] sOldValue, const char[] sNewValue)
{
	strcopy(g_sEndTime, sizeof(g_sEndTime), sNewValue);
}

public void OnMapStart() 
{
	g_bGive = false;
	
	Timer_CheckTime(INVALID_HANDLE);

	CreateTimer(60.0, Timer_CheckTime, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
}

#define HOURS	0
#define MINUTES	1

public Action Timer_CheckTime(Handle hTimer)
{
	char szTime[64];
	int iCurrentTime[2], iStartTime[2], iEndTime[2];
	FormatTime(szTime, sizeof(szTime), "%H:%M");
	GetIntDate(szTime, iCurrentTime);
	GetIntDate(g_sStartTime, iStartTime);
	GetIntDate(g_sEndTime, iEndTime);
	// LogMessage("szTime: %s (%d, %d)", szTime, iCurrentTime[HOURS], iCurrentTime[MINUTES]);
	// LogMessage("g_sStartTime: %s (%d, %d)", g_sStartTime, iStartTime[HOURS], iStartTime[MINUTES]);
	// LogMessage("g_sEndTime: %s (%d, %d)", g_sEndTime, iEndTime[HOURS], iEndTime[MINUTES]);

	bool bGive = g_bGive;

	if(iEndTime[HOURS] < iStartTime[HOURS])
	{
		g_bGive = IsTimeInPeriod(iCurrentTime, iStartTime, {24, 0}) ||
			IsTimeInPeriod(iCurrentTime, {0, 0}, iEndTime);
	}
	else
	{
		g_bGive = IsTimeInPeriod(iCurrentTime, iStartTime, iEndTime);
	}

	if (!g_bGive && bGive)
	{
		RemoveVipFromClients();
	} else if (g_bGive && !bGive)
	{
		GiveVipForClients();
	}


	return Plugin_Continue;
}

bool IsTimeInPeriod(int iTime[2], int iStartTime[2], int iEndTime[2])
{
	// LogMessage("IsTimeInPeriod: [%d, %d], [%d, %d], [%d, %d]", iTime[HOURS], iTime[MINUTES], iStartTime[HOURS], iStartTime[MINUTES], iEndTime[HOURS], iEndTime[MINUTES]);
	// If within one first hour
	if(iTime[HOURS] == iStartTime[HOURS])
	{
		// If within one latest hour
		if(iTime[HOURS] == iEndTime[HOURS])
		{
			return (iTime[MINUTES] >= iStartTime[MINUTES] && iTime[MINUTES] < iEndTime[MINUTES]);
		}

		return (iTime[MINUTES] >= iStartTime[MINUTES]);
	}

	if(iTime[HOURS] > iStartTime[HOURS])
	{
		if(iTime[HOURS] < iEndTime[HOURS])
		{
			return true;
		}

		// If within one latest hour
		if(iTime[HOURS] == iEndTime[HOURS])
		{
			return (iTime[MINUTES] < iEndTime[MINUTES]);
		}
	}

	return false;
}

void GetIntDate(const char[] szTime, int iDate[2])
{
	char szParts[2][4];
	ExplodeString(szTime, ":", szParts, sizeof(szParts), sizeof(szParts[]));
	iDate[0] = StringToInt(szParts[0]);
	iDate[1] = StringToInt(szParts[1]);
}

public void VIP_OnClientLoaded(int iClient, bool bIsVIP)
{
	if(g_bGive && !bIsVIP)
	{
		CreateTimer(3.0, Timer_DelayConnect, GetClientUserId(iClient));
	}
}

public Action Timer_DelayConnect(Handle hTimer, int iUserId)
{
	int iClient = GetClientOfUserId(iUserId);
	if (g_bGive && iClient && IsClientInGame(iClient) && !VIP_IsClientVIP(iClient))
	{
		GiveVipToClient(iClient);
	}

	return Plugin_Stop;
}

void GiveVipToClient(int iClient)
{
	VIP_GiveClientVIP(-1, iClient, 0, g_szGroup, false);
	g_bGived[iClient] = true;
}

void RemoveVipFromClients()
{
	for (int i = 1; i <= MaxClients; ++i)
	{
		if (g_bGived[i] && IsClientInGame(i) && VIP_IsClientVIP(i))
		{
			g_bGived[i] = false;
			// TODO: change initiator to -1
			VIP_RemoveClientVIP2(0, i, false, true);
		}
	}
}

void GiveVipForClients()
{
	for (int i = 1; i <= MaxClients; ++i)
	{
		if (!g_bGived[i] && IsClientInGame(i) && !VIP_IsClientVIP(i))
		{
			GiveVipToClient(i);
		}
	}
}

public void OnClientDisconnect(int iClient)
{
	g_bGived[iClient] = false;
}

